Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkKochanekSpline Class Reference

`#include <vtkKochanekSpline.h>`

Inheritance diagram for vtkKochanekSpline:

[legend]
Collaboration diagram for vtkKochanekSpline:

[legend]
List of all members.

## Detailed Description

computes an interpolating spline using a Kochanek basis.

Date:
  2002/11/12 20:09:10

Revision:
  1.25

Implements the Kochenek interpolating spline described in: Kochanek, D., Bartels, R., "Interpolating Splines with Local Tension, Continuity, and Bias Control," Computer Graphics, vol. 18, no. 3, pp. 33-41, July 1984. These splines give the user more control over the shape of the curve than the cardinal splines implemented in vtkCardinalSpline. Three parameters can be specified. All have a range from -1 to 1.

Tension controls how sharply the curve bends at an input point. A value of -1 produces more slack in the curve. A value of 1 tightens the curve.

Continuity controls the continuity of the first derivative at input points.

Bias controls the direction of the curve at it passes through an input point. A value of -1 undershoots the point while a value of 1 overshoots the point.

These three parameters give the user broad control over the shape of the interpolating spline. The original Kochanek paper describes the effects nicely and is recommended reading.

See also:
  vtkSpline vtkCardinalSpline

Created by:
  - Lorensen, Bill

CVS contributions (if > 5%):
  - Lorensen, Bill (81%)
  - Schroeder, Will (11%)

CVS logs (CVSweb):
  - .`h` (`/Filtering/vtkKochanekSpline.h)`
  - .`cxx` (`/Filtering/vtkKochanekSpline.cxx)`

Examples:
  vtkKochanekSpline (Examples)

Tests:
  vtkKochanekSpline (Tests)

Definition at line 70 of file vtkKochanekSpline.h.

## Public Types
typedef vtkSpline | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | Compute ()
float | Evaluate (float t)
virtual void | DeepCopy (vtkSpline *s)
virtual void | SetDefaultBias (float)
virtual float | GetDefaultBias ()
virtual void | SetDefaultTension (float)
virtual float | GetDefaultTension ()
virtual void | SetDefaultContinuity (float)
virtual float | GetDefaultContinuity ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkKochanekSpline * | SafeDownCast (vtkObject *o)
vtkKochanekSpline * | New ()
## Protected Methods
| vtkKochanekSpline ()
| ~vtkKochanekSpline ()
void | Fit1D (int n, float *x, float *y, float tension, float bias, float continuity, float coefficients[][4], int leftConstraint, float leftValue, int rightConstraint, float rightValue)
## Protected Attributes
float | DefaultBias
float | DefaultTension
float | DefaultContinuity

## Member Typedef Documentation

typedef vtkSpline vtkKochanekSpline::Superclass

| Reimplemented from vtkSpline. Definition at line 73 of file vtkKochanekSpline.h.

## Constructor & Destructor Documentation

vtkKochanekSpline::vtkKochanekSpline | ( |  | ) | `[protected]`

vtkKochanekSpline::~vtkKochanekSpline | ( |  | ) | `[inline, protected]`

| Definition at line 109 of file vtkKochanekSpline.h.

## Member Function Documentation

virtual const char* vtkKochanekSpline::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkSpline.

int vtkKochanekSpline::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkSpline.

virtual int vtkKochanekSpline::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkSpline.

vtkKochanekSpline* vtkKochanekSpline::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkSpline.

void vtkKochanekSpline::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkSpline.

vtkKochanekSpline* vtkKochanekSpline::New | ( |  | ) | `[static]`

| Construct a KochanekSpline with the following defaults: DefaultBias = 0, DefaultTension = 0, DefaultContinuity = 0. Reimplemented from vtkObject.

void vtkKochanekSpline::Compute | ( |  | ) | `[virtual]`

| Compute Kochanek Spline coefficients. Implements vtkSpline.

float vtkKochanekSpline::Evaluate | ( | float | t | ) | `[virtual]`

| Evaluate a 1D Kochanek spline. Implements vtkSpline.

virtual void vtkKochanekSpline::SetDefaultBias | ( | float |  | ) | `[virtual]`

| Set the bias for all points. Default is 0.

virtual float vtkKochanekSpline::GetDefaultBias | ( |  | ) | `[virtual]`

| Set the bias for all points. Default is 0.

virtual void vtkKochanekSpline::SetDefaultTension | ( | float |  | ) | `[virtual]`

| Set the tension for all points. Default is 0.

virtual float vtkKochanekSpline::GetDefaultTension | ( |  | ) | `[virtual]`

| Set the tension for all points. Default is 0.

virtual void vtkKochanekSpline::SetDefaultContinuity | ( | float |  | ) | `[virtual]`

| Set the continuity for all points. Default is 0.

virtual float vtkKochanekSpline::GetDefaultContinuity | ( |  | ) | `[virtual]`

| Set the continuity for all points. Default is 0.

virtual void vtkKochanekSpline::DeepCopy | ( | vtkSpline * | s | ) | `[virtual]`

| Deep copy of cardinal spline data. Reimplemented from vtkSpline.

void vtkKochanekSpline::Fit1D | ( | int | n,
|  | float * | x,
|  | float * | y,
|  | float | tension,
|  | float | bias,
|  | float | continuity,
|  | float | coefficients[][4],
|  | int | leftConstraint,
|  | float | leftValue,
|  | int | rightConstraint,
|  | float | rightValue
| ) | `[protected]`

## Member Data Documentation

float vtkKochanekSpline::DefaultBias`[protected]`

| Definition at line 115 of file vtkKochanekSpline.h.

float vtkKochanekSpline::DefaultTension`[protected]`

| Definition at line 116 of file vtkKochanekSpline.h.

float vtkKochanekSpline::DefaultContinuity`[protected]`

| Definition at line 117 of file vtkKochanekSpline.h.

The documentation for this class was generated from the following file:

- Filtering/vtkKochanekSpline.h